#include "stdafx.h"
#include "bf2go.h"
#include "bf2goDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

float g_fNewgamma = (float)1.00;
CString title = "BF2 - Go! - 1.0";

CBf2goDlg::CBf2goDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBf2goDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBf2goDlg)
	m_check_server = FALSE;
	m_check_mod = FALSE;
	m_server_wert = _T("");
	m_port_wert = _T("16567");
	m_mod_wert = _T("");
	m_exepfad = _T("");
	m_check_resolution = FALSE;
	m_check_name = FALSE;
	m_name_wert = _T("");
	m_resx_wert = _T("");
	m_resy_wert = _T("");
	m_check_gamma = FALSE;
	//}}AFX_DATA_INIT

}

void CBf2goDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBf2goDlg)
	DDX_Control(pDX, IDC_CHECK_MOD, m_check_mod_edit);
	DDX_Control(pDX, IDC_STATIC1, m_gammatext);
	DDX_Control(pDX, IDC_RES_Y, m_resy_edit);
	DDX_Control(pDX, IDC_RES_X, m_resx_edit);
	DDX_Control(pDX, IDC_PLAYERNAME, m_name_edit);
	DDX_Control(pDX, IDC_MOD, m_mod_box);
	DDX_Control(pDX, IDC_PORT, m_port_edit);
	DDX_Control(pDX, IDC_SERVER, m_server_edit);
	DDX_Check(pDX, IDC_CHECK_SERVER, m_check_server);
	DDX_Check(pDX, IDC_CHECK_MOD, m_check_mod);
	DDX_Text(pDX, IDC_SERVER, m_server_wert);
	DDX_Text(pDX, IDC_PORT, m_port_wert);
	DDX_CBString(pDX, IDC_MOD, m_mod_wert);
	DDX_Text(pDX, IDC_PFAD, m_exepfad);
	DDX_Check(pDX, IDC_CHECK_RESOLUTION, m_check_resolution);
	DDX_Check(pDX, IDC_CHECK_NAME, m_check_name);
	DDX_Text(pDX, IDC_PLAYERNAME, m_name_wert);
	DDX_Text(pDX, IDC_RES_X, m_resx_wert);
	DDX_Text(pDX, IDC_RES_Y, m_resy_wert);
	DDX_Check(pDX, IDC_CHECK_GAMMA, m_check_gamma);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBf2goDlg, CDialog)
	//{{AFX_MSG_MAP(CBf2goDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnButtonStart)
	ON_BN_CLICKED(IDC_CHECK_SERVER, OnCheckServer)
	ON_BN_CLICKED(IDC_CHECK_MOD, OnCheckMod)
	ON_BN_CLICKED(IDC_BUTTON_SUCH, OnButtonFind)
	ON_BN_CLICKED(IDC_CHECK_RESOLUTION, OnCheckResolution)
	ON_BN_CLICKED(IDC_CHECK_NAME, OnCheckName)
	ON_BN_CLICKED(IDC_CHECK_GAMMA, OnCheckGamma)
	ON_EN_CHANGE(IDC_PFAD, OnChangePfad)
	ON_WM_DESTROY()
	ON_MESSAGE(WM_HOTKEY,OnHotKey)			//Incoming Hotkey!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CBf2goDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	LoadConfig();
	CString test = Registry("get", "name", "NULL");
	m_hIcon = AfxGetApp()->LoadIcon(IDI_BF2);

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	SetWindowText(title);
	Update();
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CBf2goDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CBf2goDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBf2goDlg::OnButtonStart() 
{
	UpdateData(TRUE);

	CString execute = " +menu 1 +fullscreen 1";
	if (m_check_mod) 
	{
		CString boxtext;
		m_mod_box.GetLBText(m_mod_box.GetCurSel(), boxtext);
		if (boxtext != "bf2") execute += " +modPath mods/" + boxtext;
	}

	if (m_check_server) 
	{
		if (m_server_wert.GetLength() <7 || m_server_wert.Find(".") == -1) {AfxMessageBox("Not a valid ip address");return;}
		else execute += " +joinServer " + m_server_wert + " +port " + m_port_wert;
	}
	if (m_check_name && m_name_wert.GetLength() > 0) execute += " +playername " + m_name_wert;
	if (m_check_resolution) execute += " +szx " + m_resx_wert + " +szy " + m_resy_wert;

	if (GetFileAttributes(m_exepfad) == 0xffffffff) AfxMessageBox("Choose a path, my young padawan");
	else 
	{
		CString getpfad = m_exepfad;
		getpfad.Delete(getpfad.GetLength()-8,8);
		ShellExecute(NULL, "open", m_exepfad, execute, getpfad, SW_SHOWNORMAL);
		}
}

void CBf2goDlg::Update()
{
	m_server_edit.EnableWindow(m_check_server);
	m_port_edit.EnableWindow(m_check_server);
	m_mod_box.EnableWindow(m_check_mod);
	m_resx_edit.EnableWindow(m_check_resolution);
	m_resy_edit.EnableWindow(m_check_resolution);
	m_name_edit.EnableWindow(m_check_name);
	m_gammatext.EnableWindow(m_check_gamma);
}

void CBf2goDlg::OnCheckMod() 
{
	CString pfad = m_exepfad;
	if (pfad.GetLength() > 8) pfad.Delete(pfad.GetLength()-8,8);

	DWORD attr = GetFileAttributes(pfad);
	
	if (attr == 0xffffffff)
		{
		m_check_mod = FALSE;
		m_check_mod_edit.SetCheck(0);
		Update();
		return;
		}
	
	m_mod_box.ResetContent();

	CFileFind finder;
	BOOL bWorking = finder.FindFile(pfad + "\\Mods\\*.*");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		if (finder.IsDirectory() && !finder.IsDots()) m_mod_box.AddString(finder.GetFileName());
	}

	m_mod_box.SetCurSel(0);
	m_check_mod = !m_check_mod;
	Update();
}

void CBf2goDlg::OnButtonFind() 
{	
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, "bf2.exe", NULL, "BF2 Executable|bf2.exe||");
	dlg.m_ofn.Flags = dlg.m_ofn.Flags | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_PATHMUSTEXIST;
	if (dlg.DoModal() == IDOK)
	{
		m_exepfad = dlg.m_ofn.lpstrFile;
		UpdateData(FALSE);
	}
}

void CBf2goDlg::OnCheckServer() 
{
	m_check_server = !m_check_server;
	Update();
}

void CBf2goDlg::OnCheckResolution() 
{
	m_check_resolution = !m_check_resolution;
	Update();
}

void CBf2goDlg::OnCheckName() 
{
	m_check_name = !m_check_name;
	Update();
}

void CBf2goDlg::OnHotKey(WPARAM wParam, LPARAM lParam)	// Wird aufgerufen, wenn die Hotkeys bettigt werden
{
	if (wParam == 100) 
		{
		g_fNewgamma += (float)0.1;
		SetGamma(g_fNewgamma);
		}
	else if (wParam == 200) 
		{
		g_fNewgamma -= (float)0.1;
		SetGamma(g_fNewgamma);
		}
	else if (wParam == 300) 
		{
		g_fNewgamma = (float)1.00;
		SetGamma(g_fNewgamma);
		}
}

void CBf2goDlg::SetGamma(float Gamma)	//Setzt die Gamma auf allen angeschlossenen Monitoren
{
	WORD ramp[256*3];

	for(int i = 0; i < 256; i++) {
		ramp[i] = ramp[i+256] = ramp[i+512] = 
		(WORD)min(65535, max(0, pow((i+1) / 256.0, Gamma) * 65535 + 0.5));
	}
    SetDeviceGammaRamp(::GetDC(NULL), ramp);
}

void CBf2goDlg::OnCheckGamma() 
{
	m_check_gamma = !m_check_gamma;
	Update();

	if (m_check_gamma)
	{
		RegisterHotKey(this->m_hWnd,100,MOD_ALT,'1');
		RegisterHotKey(this->m_hWnd,200,MOD_ALT,'2');
		RegisterHotKey(this->m_hWnd,300,MOD_ALT,'3');
	}

	else if (!m_check_gamma)
	{
		UnregisterHotKey(this->m_hWnd,100);							//Hotkey Cleanup
		UnregisterHotKey(this->m_hWnd,200);
		UnregisterHotKey(this->m_hWnd,300);
	}
}

bool CBf2goDlg::LoadConfig() 
{
	Registry("create", "", "");

	CString configtest = Registry("get", "path", "NULL");
	if (configtest.GetLength() > 2) {m_exepfad = configtest;}

	configtest = Registry("get", "mod", "NULL");
	if(configtest != "-1") {OnCheckMod(); m_check_mod = TRUE; m_mod_box.SetCurSel(atoi(configtest));}
	
	configtest = Registry("get", "server", "NULL");
	if (configtest.GetLength() > 6) {m_check_server = TRUE; m_server_wert = Registry("get", "server", "NULL"); m_port_wert = Registry("get", "port", "NULL");}

	configtest = Registry("get", "resx", "NULL");
	if(configtest.GetLength() > 2 && Registry("get", "resy", "NULL").GetLength() > 2) {m_check_resolution = TRUE;m_resx_wert = configtest; m_resy_wert = Registry("get", "resy", "NULL");}

	configtest = Registry("get", "name", "NULL");
	if(configtest != "-1") {m_check_name = TRUE; m_name_wert = configtest;}

	if(Registry("get", "gamma", "NULL") == "true") {m_check_gamma = TRUE;}
	else {m_check_gamma = FALSE;}

	UpdateData(FALSE);
	Update();
	return true;
}

bool CBf2goDlg::SaveConfig() 
{
	UpdateData(TRUE);

	if (m_exepfad != "") Registry("set", "path", m_exepfad);
	else Registry("set", "path", "-1");

	if (m_check_mod) Registry("set", "mod", i2s(m_mod_box.GetCurSel()));
	else Registry("set", "mod", "-1");

	if (m_check_server) {Registry("set", "server", m_server_wert);Registry("set", "port", m_port_wert);}
	else {Registry("set", "server", "-1"); Registry("set", "port", "-1");}

	if (m_check_resolution) {Registry("set", "resx", m_resx_wert);Registry("set", "resy", m_resy_wert);}
	else {Registry("set", "resx", "-1");Registry("set", "resy", "-1");}

	if (m_check_name) Registry("set", "name", m_name_wert);
	else Registry("set", "name", "-1");

	if (m_check_gamma) Registry("set", "gamma", "true");
	else Registry("set", "gamma", "false");
	
	return true;
}

void CBf2goDlg::OnChangePfad() 
{
	UpdateData(TRUE);	
}

CString CBf2goDlg::i2s(int i) 
{
	char buffer[20];
	_itoa(i, buffer, 10);
	return (CString)buffer;	
}

void CBf2goDlg::OnDestroy() 
{
	UnregisterHotKey(this->m_hWnd,100);							//Hotkey Cleanup
	UnregisterHotKey(this->m_hWnd,200);
	UnregisterHotKey(this->m_hWnd,300);
	
	SetGamma((float)1.00);	
	
	SaveConfig();
	CDialog::OnDestroy();
}

CString CBf2goDlg::Registry(CString uebergabe, CString variable, CString wert)
{
	CString rueckgabe = "";
	HKEY registryhandle;
	
	if (uebergabe == "get")
	{		
		char buffer[256];
		ULONG bufferlaenge = sizeof(buffer);
	
		if(RegOpenKey(HKEY_CURRENT_USER, _T("Software\\bf2go"), &registryhandle) == ERROR_SUCCESS && RegQueryValueEx(registryhandle, _T(variable), NULL, NULL, (LPBYTE)buffer, &bufferlaenge) == ERROR_SUCCESS)
		{
			rueckgabe = (CString)buffer;
		}
		else rueckgabe = "";
	}

	else if (uebergabe == "create")	//Legt den Regkey an
	{
		RegCreateKey(HKEY_CURRENT_USER, _T("Software\\bf2go"), &registryhandle);
	}

	else if (uebergabe == "set")
	{
		LPSTR data = "";
		strcpy(data, wert);

		if(RegOpenKey(HKEY_CURRENT_USER, _T("Software\\bf2go"), &registryhandle) == ERROR_SUCCESS && RegSetValueEx(registryhandle, _T(variable), NULL, REG_SZ, (CONST BYTE*) data, wert.GetLength()) == ERROR_SUCCESS) 
			{
			rueckgabe = wert;
			}
		else rueckgabe = "";
	}

	RegCloseKey(registryhandle);
	return rueckgabe;
}
